// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

// THIS FILE IS AUTO-GENERATED, PLEASE DO NOT MODIFY BY HAND.

part of omnibuild.test.message_library;

class ImpureMessage extends OmnibusRequest {
  /// omnibusId
  static const id = 'omnibuild.v0.ImpureMessage';

  final List<int> pureList;

  final List<List<Point>> impureList;

  /// Constructor
  ImpureMessage(this.pureList, this.impureList) : super(id);

  /// Construct from passive data structure.
  factory ImpureMessage.fromPds(final Map<String, dynamic> pds) {
    List<int> pureList;
    List<List<Point>> impureList;

    // Read pureList.
    if (pds.containsKey('pureList') && pds['pureList'] is List) {
      pureList = new List<int>.from(pds['pureList']);
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'pureList'");
    }

    // Read impureList.
    if (pds.containsKey('impureList') && pds['impureList'] is List) {
      impureList = new List<List<Point>>.generate(
          pds['impureList'].length,
          (int i1) => new List<Point>.generate(
              pds['impureList'][i1].length,
              (int i2) => new Point.fromPds(
                  new List<int>.from(pds['impureList'][i1][i2]))));
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'impureList'");
    }

    return new ImpureMessage(pureList, impureList);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'pureList': pureList, 'impureList': toPdsList(impureList)};
  }
}

/// Message handler for ImpureMessage
class ImpureMessageHandler extends OmnibusRequestHandler {
  /// Callback
  final OmnibusRequestCallback<ImpureMessage> _callback;

  /// Constructor
  ImpureMessageHandler(this._callback) : super(ImpureMessage.id);

  /// Process incoming message.
  List<Future<OmnibusResponse>> process(OmnibusRequest data) {
    ImpureMessage message =
        data is ImpureMessage ? data : new ImpureMessage.fromPds(data.toPds());

    return [_callback(message)];
  }
}

class PureMessage extends OmnibusResponse {
  /// omnibusId
  static const id = 'omnibuild.v0.PureMessage';

  final List<int> pureList;

  final Map<String, List<Map<String, int>>> pureMap;

  /// Constructor
  PureMessage(this.pureList, this.pureMap) : super(id);

  /// Construct from passive data structure.
  factory PureMessage.fromPds(final Map<String, dynamic> pds) {
    List<int> pureList;
    Map<String, List<Map<String, int>>> pureMap;

    // Read pureList.
    if (pds.containsKey('pureList') && pds['pureList'] is List) {
      pureList = new List<int>.from(pds['pureList']);
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'pureList'");
    }

    // Read pureMap.
    if (pds.containsKey('pureMap') && pds['pureMap'] is Map) {
      pureMap = new Map<String, List<Map<String, int>>>.fromIterable(
          pds['pureMap'].keys,
          key: (String key1) => key1,
          value: (String key1) => new List<Map<String, int>>.generate(
              pds['pureMap'][key1].length,
              (int i2) => new Map<String, int>.from(pds['pureMap'][key1][i2])));
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'pureMap'");
    }

    return new PureMessage(pureList, pureMap);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'pureList': pureList, 'pureMap': pureMap};
  }
}

/// Create PureMessage Stream from the given responses.
Stream<PureMessage> streamPureMessage(OmnibusResponses responses) {
  return responses.stream(
      PureMessage.id,
      (OmnibusResponse data) => data is PureMessage
          ? data
          : new PureMessage.fromPds(data.toPds())) as Stream<PureMessage>;
}
